;--------------------------------------------------------
;--------------------GUI---------------------------------
;--------------------------------------------------------
;-------------------------------------by Zino Vieth------
;--------------------------------------------------------

Type TButton
	Field Id
	Field Width
	Field Height
	Field Txt$
	Field X
	Field Y
	Field Bg_Color_R, Bg_Color_G, Bg_Color_B
	Field Border_Color_R, Border_Color_G, Border_Color_B
	Field Bg_Color_H_R, Bg_Color_H_G, Bg_Color_H_B
	Field Border_Color_H_R, Border_Color_H_G, Border_Color_H_B
	Field Bg_Color_D_R, Bg_Color_D_G, Bg_Color_D_B
	Field Border_Color_D_R, Border_Color_D_G, Border_Color_D_B
	Field Txt_R, Txt_G, Txt_B
	Field Hovered
	Field Visible
	Field Disabled
	Field Clicked
	Field OnForm
End Type

Function tp_CreateButton(FId,id,txt$,x,y,w,h,v)
	
	b.TButton = New TButton
	b\Id = id
	b\Txt = txt
	b\Width = w
	b\Height = h
	b\X = x
	b\Y = y
	b\Visible = v
	b\OnForm = FId
	
End Function


Function tp_SetButtonBgColors(id,r1,g1,b1,r2,g2,b2,r3,g3,b3)
	
	For a.TButton = Each TButton
		If id = a\Id Then
			a\Bg_Color_R = r1
			a\Bg_Color_G = g1
			a\Bg_Color_B = b1
			a\Bg_Color_H_R = r2
			a\Bg_Color_H_G = g2
			a\Bg_Color_H_B = b2
			a\Bg_Color_D_R = r3
			a\Bg_Color_D_G = g3
			a\Bg_Color_D_B = b3
		EndIf
	Next
	
End Function


Function tp_SetButtonBorderColors(id,r1,g1,b1,r2,g2,b2,r3,g3,b3)
	
	For a.TButton = Each TButton
		If id = a\Id Then
			a\Border_Color_R = r1
			a\Border_Color_G = g1
			a\Border_Color_B = b1
			a\Border_Color_H_R = r2
			a\Border_Color_H_G = g2
			a\Border_Color_H_B = b2
			a\Border_Color_D_R = r3
			a\Border_Color_D_G = g3
			a\Border_Color_D_B = b3
		EndIf
	Next
	
End Function


Function tp_UpdateButtonState()

	For a.TButton = Each TButton
		If Maus_X > a\X And Maus_X < a\X + a\Width Then
			If Maus_Y > a\Y And Maus_y < a\Y + a\Height Then
				If a\Visible = 1 And a\Disabled = 0 Then
					a\Hovered = 1
				Else
					a\Hovered = 0
				EndIf
			Else
				a\Hovered = 0
			EndIf
		Else
			a\Hovered = 0
		EndIf
	Next

End Function


Function tp_DisableButton(id)

	For a.TButton = Each TButton
		If id = a\Id Then
			a\Disabled = a\Disabled + 1
			If a\Disabled > 1 Then a\Disabled = 0
		EndIf
	Next
	
End Function


Function tp_VisibleButton(id)

	For a.TButton = Each TButton
		If id = a\Id Then
			a\Visible = a\Visible + 1
			If a\Visible > 1 Then a\Visible = 0
		EndIf
	Next
	
End Function
	
	
Function tp_DrawButtons()

	For a.TButton = Each TButton	
		If a\Visible = 1 Then
		
			If a\Disabled = 1 Then
				r1 = a\Bg_Color_D_R
				g1 = a\Bg_Color_D_G
				b1 = a\Bg_Color_D_B
				r2 = a\Border_Color_D_R
				g2 = a\Border_Color_D_G
				b2 = a\Border_Color_D_B
			ElseIf a\Hovered = 1 Then
				r1 = a\Bg_Color_H_R
				g1 = a\Bg_Color_H_G
				b1 = a\Bg_Color_H_B
				r2 = a\Border_Color_H_R
				g2 = a\Border_Color_H_G
				b2 = Border_Color_H_B
			Else
				r1 = a\Bg_Color_R
				g1 = a\Bg_Color_G
				b1 = a\Bg_Color_B
				r2 = a\Border_Color_R
				g2 = a\Border_Color_G
				b2 = a\Border_Color_B
			EndIf
			
			Color r1,g1,b1
			Rect a\X,a\Y,a\Width,a\Height,1
			Color a\Txt_R,a\Txt_G,a\Txt_B
			Text a\X + (a\Width/2),a\Y + (a\Height/2),a\Txt,1,1
			Color r2,g2,b2
			Rect a\X,a\Y,a\Width,a\Height,0
			
			Color super_r,super_g,super_b
			
		EndIf	
	Next
	
End Function


Function tp_ChangeButtonText(id,txt$)

	For a.TButton = Each TButton
		If a\Id = id Then
			a\Txt = txt
		EndIf
	Next
	
End Function


Function tp_DeleteButton(id)

	For a.TButton = Each TButton
		If a\Id = id Then
			Delete a.TButton
		EndIf
	Next
	
End Function


Function tp_SetButtonTextColor(id,r,g,b)

	For a.TButton = Each TButton
		If a\Id = id Then
			a\Txt_R = r
			a\Txt_G = g
			a\Txt_B = b
		EndIf
	Next
	
End Function


Global mouse_over
Function tp_MouseOutOfClick(id)

	For a.TButton = Each TButton
		If id = a\Id Then
			If Not Maus_X > a\X And Maus_x < a\X + a\Width Then
				If Not Maus_y > a\Y And Maus_Y < a\Y + a\Height Then
					fail = 1
				EndIf
			EndIf
		EndIf
	Next
	If fail = 1 Then
		FlushMouse()
		Return True
	Else
		Return False
	EndIf

End Function


Function tp_ButtonClick(id)

	For a.TButton = Each TButton
		
		If a\Id = id Then
		
			If Maus_Left = 1 Then	
				If a\Hovered = 1 Then
					Return True
				Else
					Return False
				EndIf
			Else
				Return False
			EndIf
			
		EndIf
	Next

End Function
