
Type TComboBox
	Field Id
	Field X, Y
	Field Width, Height
	Field Visible, Disabled, Active
	Field StartItem, ItemCounter
	Field Item$[100], ItemId[100]
	Field OnForm
End Type


Function tp_CreateComboBox(FId,id,x,y,w,h,v)
	a.TComboBox = New TComboBox
	a\Id = id
	a\X = x
	a\Y = y
	a\Visible = v
	a\Width = w
	a\Height = h
	a\Active = 1
	a\OnForm = FId
End Function


Function tp_AddComboBoxItem(id,txt$)
	For a.TComboBox = Each TComboBox
		If a\Id = id Then
			a\ItemCounter = a\ItemCounter + 1
			If a\ItemCounter > 100 Then a\ItemCounter = 100
			
			a\Item[a\ItemCounter] = txt
			a\ItemId[a\ItemCounter] = a\ItemCounter
		EndIf
	Next
End Function


Function tp_SetComboBoxStartItem(id,txt$)
	For a.TComboBox = Each TComboBox
		If a\Id = id Then
			For i = 1 To a\ItemCounter
				If a\Item[i] = txt Then 
					a\StartItem = a\ItemId[i]
				EndIf
			Next
		EndIf
	Next
End Function


Function tp_DisableComboBox(id)
	For a.TComboBox = Each TComboBox
		If a\Id = id Then
			a\Disabled = a\Disabled + 1
			If a\Disabled > 1 Then a\Disabled = 0
		EndIf
	Next
End Function


Function tp_UpdateComboBox()
	For a.TComboBox = Each TComboBox
		If a\Visible = 1 And a\Disabled <> 1 Then			
			If Maus_Left = 1 Then
							
				If Maus_X > a\X And Maus_X < a\X + a\Width
					If Maus_Y > a\Y And Maus_Y < a\Y + a\Height
						a\Active = a\Active + 1
						If a\Active > 1 Then a\Active = 0
					Else
						a\Active = 0
					EndIf
				Else
					a\Active = 0
				EndIf

				If a\Active <> 1 Then
					For i = 1 To a\ItemCounter 
						If Maus_X > a\X And Maus_X < a\X + a\Width Then
							If Maus_Y > a\Y + (i*a\Height) And Maus_Y < a\Y + a\Height + (i*a\Height) Then
								a\StartItem = a\ItemId[i]
							Else
								a\Active = 0
							EndIf
						Else
							a\Active = 0
						EndIf
					Next
				EndIf
				
			EndIf		
		EndIf
	Next
End Function


Function tp_DrawComboBox()
	For a.TComboBox = Each TComboBox
		If a\Visible = 1 Then
			If a\Disabled = 1 Then
				r1 = 10
				r2 = 17
				Color r1,r1,r1
				Rect a\X,a\Y,a\Width,a\Height,1
				Color r2,r2,r2
				Rect a\X,a\Y,a\Width,a\Height,0
				Color 255,255,255
				For i = 1 To a\ItemCounter
					If a\StartItem = a\ItemId[i]
						Text a\X+a\Width/2,a\Y+a\Height/2,a\Item[i],1,1
					EndIf
				Next
			ElseIf a\Active = 1 Then
				rg1 = 0
				b1 = 255
				rg2 = 100
				b2 = 255
				r3 = 200
				r4 = 217
				Color rg1,rg1,b1
				Rect a\X,a\Y,a\Width,a\Height,1
				Color rg2,rg2,b2
				Rect a\X,a\Y,a\Width,a\Height,0
				Color 0,0,0
				Text a\X+a\Width/2,a\Y+a\Height/2,a\Item[a\StartItem],1,1
				For i = 1 To a\ItemCounter
					Color r3,r3,r3
					Rect a\X,a\Y+i*a\Height,a\Width,a\Height,1
					Color r4,r4,r4
					Rect a\X,a\Y+i*a\Height,a\Width,a\Height,0
					Color 255,255,255
					Text a\X+a\Width/2,a\Y+a\Height/2+i*a\Height,a\Item[i],1,1
				Next
			Else
				Color 100,100,100
				Rect a\X,a\Y,a\Width,a\Height,1
				Color 255,255,255
				Rect a\X,a\Y,a\Width,a\Height,0
				Color 0,0,0
				For i = 1 To a\ItemCounter
					If a\StartItem = a\ItemId[i] Then
						Text a\X+a\Width/2,a\Y+a\Height/2,a\Item[i],1,1
					EndIf
				Next
			EndIf
		EndIf
	Next
End Function	


Function tp_ActivateComboBox(id)
	For a.TComboBox = Each TComboBox
		If a\Id = id Then
			a\Active = 1
		EndIf
	Next
End Function


Function tp_ChangeComboBoxCoords(id,x,y)
	For a.TComboBox = Each TComboBox
		If a\Id = id Then
			a\X = x
			a\Y = y
		EndIf
	Next
End Function


Function tp_DeleteComboBoxItem(id,txt$)
	For a.TComboBox = Each TComboBox
		If a\Id = id Then
			For i = 1 To a\ItemCounter
				If a\Item[i] = txt Then 
					Item[i] = ""
					gefunden = 1
					a\ItemCounter = a\ItemCounter - 1
				ElseIf gefunden = 1 Then
					a\Item[i-1] = a\Item[i]
					a\Item[i] = ""
				EndIf
			Next
		EndIf
	Next
End Function
			