Type TLabel
	Field Id
	Field Txt$
	Field Visible
	Field R,G,B
	Field Border, Border_Set
	Field B_R,B_G,B_B
	Field BG, BG_Set
	Field BG_R,BG_G,BG_B
	Field X, Y
	Field OnForm
	Field Width
	Field Height
	Field Font
End Type


Function tp_CreateLabel(FId,id,txt$,r,g,b,x,y,w,h,v)
	a.TLabel = New TLabel
	a\OnForm = FId
	a\Id = id
	a\Txt = txt
	a\Visible = v
	a\R = r
	a\G = g
	a\B = b
	a\X = x
	a\Y = y
	a\Width = w
	a\Height = h
End Function


Function tp_ChangeLabelFont(id,s$,g,f,k,u)
	For a.TLabel = Each TLabel
		If a\Id = id Then
			a\Font = LoadFont(s,g,f,k,u)
		EndIf
	Next
End Function


Function tp_AddLabelBG(id,r,g,b)
	For a.TLabel = Each TLabel
		If a\Id = id Then
			a\BG = 1
			a\BG_Set = 1
			a\BG_R = r
			a\BG_G = g
			a\BG_B = b
		EndIf
	Next
End Function


Function tp_AddLabelBorder(id,r,g,b)
	For a.TLabel = Each TLabel
		If a\Id = id Then
			a\Border = 1
			a\Border_Set = 1
			a\B_R = r
			a\B_G = g
			a\B_B = b
		EndIf
	Next
End Function


Function tp_DisableLabelBG(id)
	For a.TLabel = Each TLabel
		If a\Id = id And a\BG_Set = 1 Then
			a\BG = 0
		EndIf
	Next
End Function


Function tp_EnableLabelBG(id)
	For a.TLabel = Each TLabel
		If a\Id = id And a\BG_Set = 1 Then
			a\BG = 1
		EndIf
	Next
End Function


Function tp_DisableLabelBorder(id)
	For a.TLabel = Each TLabel
		If a\Id = id And a\Border_Set = 1 Then
			a\Border = 0
		EndIf
	Next
End Function


Function tp_EnableLabelBorder(id)
	For a.TLabel = Each TLabel
		If a\Id = id And a\Border_Set = 1 Then
			a\Border = 1
		EndIf
	Next
End Function


Function tp_ChangeLabelText(id,txt$)
	For a.TLabel = Each TLabel
		If a\Id = id Then
			a\Txt = txt
		EndIf
	Next
End Function


Function tp_ChangeLabelCoords(id,x,y)
	For a.TLabel = Each TLabel
		If a\Id = id Then
			a\X = x
			a\Y = y
		EndIf
	Next
End Function


Function tp_PutLabelOnForm(id,FId)
	For a.TLabel = Each TLabel
		If a\Id = id Then
			a\OnForm = FId
			For b.TForm = Each TForm
				If b\Id = FId
					If b\Visible = 1 Then
						a\Visible = 1
					Else
						a\Visible = 0
					EndIf
				EndIf
			Next
		EndIf
	Next
End Function


Function tp_ChangeLabelSizes(id,w,h)
	For a.TLabel = Each TLabel
		If a\Id = id Then
			a\Width = w
			a\Height = h
		EndIf
	Next
End Function


Function tp_DrawLabels()
	For a.TLabel = Each TLabel
		If a\Visible = 1 Then
			If a\BG = 1 Then
				Color a\BG_R,a\BG_G,a\BG_B
				Rect a\X,a\Y,a\Width,a\Height,1
			EndIf
			If a\Border = 1 Then
				Color a\B_R,a\B_G,a\B_B
				Rect a\X,a\Y,a\Width,a\Height,0
			EndIf
			Color a\R,a\G,a\B
			If a\Font <> False Then SetFont a\Font
			Text a\X+a\Width/2,a\Y+a\Height/2,a\Txt
			SetFont super_font
		EndIf
	Next
End Function