
Type TTextField
	Field Id
	Field X, Y
	Field Width, Height
	Field Txt$, Value$
	Field Visible, Disabled, Active
	Field Auto
	Field OnForm
End Type



Function tp_CreateTextField(FId,id,v$,x,y,w,h,au,vi)
	a.TTextField = New TTextField
	a\Id = id
	a\X = x
	a\Y = y
	a\Width = w
	a\Height = h
	a\Value = v
	If vi > 0 Then a\Visible = 1
	If au > 0 Then a\Auto = 1
	a\OnForm = FId
End Function


Function tp_UpdateTextFields()
	ascx = GetKey()
	newx$ = Chr(ascx)
	For a.TTextField = Each TTextField
		If a\Disabled = 0 And a\Visible = 1 And a\Active = 1 Then
			If KeyHit(28) Then a\Active = 0
			If ascx <> 8 Then
				If ascx = 0 Then Exit
				a\Txt = a\Txt + newx
			ElseIf ascx = 8 Then
				If a\Txt = "" Then Exit
				a\Txt = Left(a\Txt, Len(a\Txt)-1)
			EndIf
		EndIf
	Next
End Function


Function tp_GetTextFieldState(id)
	For a.TTextField = Each TTextField
		If a\Id = id Then
			If a\Visible = 1 Then
				If a\Disabled = 1 Then
					Return DISABLED
				ElseIf a\Active = 1 Then
					Return ACTIVE
				Else
					Return VISIBLE
				EndIf
			Else
				Return INVISIBLE
			EndIf 
		EndIf
	Next
End Function


Function tp_ActivateTextField(id)
	For a.TTextField = Each TTextField
		If a\Id = id Then
			If a\Disabled <> 1 And a\Visible = 1 Then
				a\Active = 1
			EndIf
		EndIf
	Next
End Function


Function tp_TextFieldAutoActivate()
	For a.TtextField = Each TTextField
		If a\Auto = 1 Then
			If a\Visible = 1 And a\Disabled <> 1 Then
				If Maus_Left Then
					If Maus_X > a\X And Maus_x < a\X + a\Width Then
						If Maus_y > a\Y And Maus_y < a\Y + a\Height Then
							a\Active = 1
						Else
							a\Active = 0
						EndIf
					Else
						a\Active = 0
					EndIf
				EndIf
			EndIf
		EndIf
	Next
End Function


Function tp_DisableTextField(id)
	For a.TTextField = Each TTextField
		If a\Id = id Then
			If a\Visible = 1 Then
				a\Disabled = a\Disabled + 1
				If a\Disabled > 1 Then a\Disabled = 0
			EndIf
		EndIf
	Next
End Function


Function tp_DrawTextFields()
	For a.TTextField = Each TTextField
		If a\Visible = 1 Then
			If a\Disabled = 1 Then
				r1 = 10
				r2 = 17
			ElseIf a\Active = 1 Then
				r1 = 200
				r2 = 217
			Else
				r1 = 100
				r2 = 117
			EndIf
			Color r1,r1,r1
			Rect a\X,a\Y,a\Width,a\Height,1
			Color r2,r2,r2
			Rect a\X,a\Y,a\Width,a\Height,0
			Color 0,0,0
			If a\Txt <> "" Then
				Text a\X+5,a\Y+(a\Height/2),a\Txt,0,1
			Else
				Text a\X+5,a\Y+(a\Height/2),a\Value,0,1
			EndIf
			
			Color super_r,super_g,super_b
		EndIf
	Next
End Function


Function tp_GetTextFieldText$(id)
	For a.TTextField = Each TTextField
		If a\Id = id Then
			If a\Txt <> False Then
				Return a\Txt
			Else
				If a\Value <> False Then
					Return a\Value
				Else
					Return ""
				EndIf
			EndIf
		EndIf
	Next
End Function


Function tp_SetTextFieldText(id,txt)
	For a.TTextField = Each TTextField
		If a\Id = id Then
			a\Txt = txt
		EndIf
	Next
End Function

	